unit WSIS_Basics_;

{*************************************************************************

File:

  "Basic techniques" demo for the WebSiteInside component.

Description:

  This form demonstrates such features of the WebSiteInside component
  as serving a simple dynamically generated page, getting data from an
  HTML form and handling incorrect page references.

Requirements:

  a) Borland Delphi4 or Delphi5. The component and the sample might also
  work (with minor changes) on Delphi3, but that as never been tested.
  b) MS WebBrowser ActiveX (comes with IE4+) must be installed in Delphi.

Distribution policy:

  This sample uses TWebSiteInside, which is a shareware component -
  see the license agreement text included in the WSISxxx.ZIP package.
  As long as you conform to that license agreement, you may modify
  the source code of this sample as you wish and use it freely in
  your applications.

Author :  Alexei Reatov
EMail  :  alexei@wbcontrols.com
WebSite:  http://www.wbcontrols.com
Date   :  July 14, 2000

**************************************************************************}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  WebSiteInside, ComCtrls, StdCtrls, ToolWin, OleCtrls
  {$ifdef VER130}
    , SHDocVw
  {$else}
    , ShDocVw_TLB
  {$endif};

type
  TForm1 = class(TForm)
    WB: TWebBrowser;
    ToolBar1: TToolBar;
    Button1: TButton;
    ToolButton1: TToolButton;
    Memo1: TMemo;
    wsiTimerPage: TWebSiteInside;
    ComboBox1: TComboBox;
    wsiFormTest: TWebSiteInside;
    procedure Button1Click(Sender: TObject);
    procedure wsiRootPageNotFound(Sender: TWebDataItem;
      const sURL: String; var Data: String);
    procedure FormCreate(Sender: TObject);
    procedure wsiTimerItems0GetData(Sender: TObject; const sURL: String;
      var Data: String);
    procedure wsiHelpPageNotFound(Sender: TObject; const sURL: String;
      var Data: String);
    procedure WebSiteInside1Items1GetData(Sender: TObject;
      const sURL: String; var Data: String);
  private
    procedure Log(s: string);
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
var
  wsUrl: WideString;
  v: OleVariant;
begin
  wsUrl := ComboBox1.Text;
  WB.Navigate(wsUrl, v, v, v, v);
end;

procedure TForm1.wsiRootPageNotFound(Sender: TWebDataItem;
  const sURL: String; var Data: String);
begin
  Memo1.Lines.Add(sUrl);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  ComboBox1.ItemIndex := 0;
end;

procedure TForm1.wsiTimerItems0GetData(Sender: TObject; const sURL: String;
  var Data: String);
var
  i: Integer;
  s: string;
begin
  i := Pos('%%time%%', Data);
  if i <= 0 then Exit;
  s := FormatDateTime('hh:nn:ss', Now);
  Data := Copy(Data, 1, i-1) + s + Copy(Data, i+8, 99999);
end;

procedure TForm1.wsiHelpPageNotFound(Sender: TObject; const sURL: String;
  var Data: String);
begin
  Data :=
    '<HTML>Sorry, the following page can not be found in you application: <p>' +
    '<b>' + sURL + '</b>' +
    '<p>(served by Web-Site-Inside 1.0)' +
    '</html>';
end;

procedure TForm1.Log(s: string);
begin
  Memo1.Lines.Add(s);
end;

procedure TForm1.WebSiteInside1Items1GetData(Sender: TObject;
  const sURL: String; var Data: String);
begin
  Log('Form submission received:');
  Log('URL = ' + sURL);
  Data := '<html><b>OK</b>, got it!</html>';
end;

end.
