unit WSIS_db_;

{*************************************************************************

File:

  "Using HTML producers" demo for the WebSiteInside component.

Description:

  This form opens a table from Delphi's sample database and shows the data
  as HTML in an embedded WebBrowser component.  The sample uses the
  standard BDE components and TDataSetTableProducer to obtain the data from
  the table and format it as HTML, then serves it to the WebBrowser through
  a WebSiteInside component.

Requirements:

  a) Borland Delphi4 or Delphi5. The component and the sample might also
  work (with minor changes) on Delphi3, but that as never been tested.
  b) MS WebBrowser ActiveX (comes with IE4+) must be installed in Delphi.
  c) Database and Internet components
  d) The standard DBDEMOS database

Distribution policy:

  This sample uses TWebSiteInside, which is a shareware component -
  see the license agreement text included in the WSISxxx.ZIP package.
  As long as you conform to that license agreement, you may modify
  the source code of this sample as you wish and use it freely in
  your applications.

Author :  Alexei Reatov
EMail  :  alexei@wbcontrols.com
WebSite:  http://www.wbcontrols.com
Date   :  July 14, 2000

**************************************************************************}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ToolWin, Grids, DBGrids, HTTPApp, DBWeb, Db,
  DBTables, OleCtrls, WebSiteInside
  {$ifdef VER130}
    , SHDocVw
  {$else}
    , ShDocVw_TLB
  {$endif};


type
  TForm2 = class(TForm)
    DataSource1: TDataSource;
    WB: TWebBrowser;
    Table1: TTable;
    Producer: TDataSetTableProducer;
    DBGrid1: TDBGrid;
    ToolBar1: TToolBar;
    ComboBox1: TComboBox;
    ToolButton1: TToolButton;
    Button1: TButton;
    WebSiteInside1: TWebSiteInside;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure WebSiteInside1Items0GetData(Sender: TObject;
      const sURL: String; var Data: String);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;

implementation

{$R *.DFM}

procedure TForm2.FormCreate(Sender: TObject);
begin
  ComboBox1.ItemIndex := 0;
end;

procedure TForm2.Button1Click(Sender: TObject);
var
  wsUrl: WideString;
  v: OleVariant;
begin
  wsUrl := ComboBox1.Text;
  WB.Navigate(wsUrl, v, v, v, v);
end;

procedure TForm2.WebSiteInside1Items0GetData(Sender: TObject;
  const sURL: String; var Data: String);
begin
  Table1.First;
  Data := '<html>' + Producer.Content + '</html>';
end;

end.
